@echo off

rem -------------------------------------------
rem - generates a make file, then executes it -
rem -------------------------------------------

rem usage
rem -----
rem 
rem requires cmd.exe console with the /V:ON option
rem
rem execute make.bat
rem put 'd' on command line for debug compilation and link
rem 
rem to debug make execution, change execution line at the end of the file to:
rem %MAKE% -K -n -p -m -a -r -f%PROJECT_NAME%.mak

rem modification
rem ------------
rem 
rem change the values of BORLAND_HOME and PROJECT_BASE



set BORLAND_HOME=C:\h\borland\bcc55
set PROJECT_BASE=C:\h\dev

set PROJECT_NAME=perceptuum2
set PROJECT_HOME=%PROJECT_BASE%\%PROJECT_NAME%
set PROJECT_SOURCE=%PROJECT_HOME%\source
set PROJECT_LIBS=%PROJECT_HOME%\libs
set MAKE=%BORLAND_HOME%\bin\MAKE

if "%1"=="d" (
	set DEBUG=true
	echo debug
) else (
	set DEBUG=false
	echo release
)



rem --- start of file --- 

echo #MAKE -a -r -f%PROJECT_NAME%.mak > %PROJECT_NAME%.mak
echo. >> %PROJECT_NAME%.mak
echo .autodepend >> %PROJECT_NAME%.mak
echo. >> %PROJECT_NAME%.mak


echo PROJECT_NAME = perceptuum2 >> %PROJECT_NAME%.mak
echo. >> %PROJECT_NAME%.mak



rem --- locations --- 

echo BORLAND_HOME = %BORLAND_HOME% >> %PROJECT_NAME%.mak
echo BORLAND_BIN = $(BORLAND_HOME)\bin >> %PROJECT_NAME%.mak
echo BORLAND_INC = $(BORLAND_HOME)\include >> %PROJECT_NAME%.mak
echo BORLAND_LIB = $(BORLAND_HOME)\lib;$(BORLAND_HOME)\lib\psdk >> %PROJECT_NAME%.mak

echo PROJECT_HOME = %PROJECT_BASE%\$(PROJECT_NAME) >> %PROJECT_NAME%.mak
echo PROJECT_SOURCE = $(PROJECT_HOME)\source >> %PROJECT_NAME%.mak
echo PROJECT_LIB = $(PROJECT_HOME)\libs >> %PROJECT_NAME%.mak

echo RESOURCE_DIR = $(PROJECT_SOURCE)\platform\ui\resources >> %PROJECT_NAME%.mak
echo LIB_DIRS = $(BORLAND_LIB);$(PROJECT_LIB) >> %PROJECT_NAME%.mak
echo OBJ_DIR = $(PROJECT_HOME)\output >> %PROJECT_NAME%.mak
echo. >> %PROJECT_NAME%.mak



rem --- switches/options ---

echo COMPILER = $(BORLAND_BIN)\BCC32 >> %PROJECT_NAME%.mak
echo RES_COMPILER = $(BORLAND_BIN)\BRCC32 >> %PROJECT_NAME%.mak
echo LINKER = $(BORLAND_BIN)\ILINK32 >> %PROJECT_NAME%.mak

echo STACK_RESERVE = -S:0x100000 >> %PROJECT_NAME%.mak
echo STACK_COMMIT = -Sc:0x10000 >> %PROJECT_NAME%.mak
echo HEAP_RESERVE = -H:0x2000000 >> %PROJECT_NAME%.mak
echo HEAP_COMMIT = -Hc:0x400000 >> %PROJECT_NAME%.mak

echo IMAGE_COMMENT = -GC"{created by: harrison artifex, london, 2002 - www.hxa7241.org}" >> %PROJECT_NAME%.mak

echo LOGGING_ENABLE = true >> %PROJECT_NAME%.mak

if "%DEBUG%"=="true" (
	goto optionsdebug
) else (
	goto optionsrelease
)
:optionsdebug
	echo COMPILER_OPTIONS = -pr -k -5 -Od -v -y -H- -w -tWM -DWINVER=0x0400 -D_WIN32_WINNT=0x0400 -DBORLANDCPP551 -DLOGGING_ENABLED=$(LOGGING_ENABLE) >> %PROJECT_NAME%.mak
	echo LINKER_OPTIONS = /v /m -aa -c -C $(IMAGE_COMMENT) -Gn $(STACK_RESERVE) $(STACK_COMMIT) $(HEAP_RESERVE) $(HEAP_COMMIT) >> %PROJECT_NAME%.mak
	goto optionsend
:optionsrelease
	echo COMPILER_OPTIONS = -pr -k- -5 -O2 -OS -Oc -Oi -Ov -v- -H- -w -tWM -DWINVER=0x0400 -D_WIN32_WINNT=0x0400 -DBORLANDCPP551 -DLOGGING_ENABLED=$(LOGGING_ENABLE) >> %PROJECT_NAME%.mak
	echo LINKER_OPTIONS = -aa -c -C $(IMAGE_COMMENT) -Gn -x $(STACK_RESERVE) $(STACK_COMMIT) $(HEAP_RESERVE) $(HEAP_COMMIT) >> %PROJECT_NAME%.mak
:optionsend

echo EXE_NAME = $(PROJECT_NAME).exe >> %PROJECT_NAME%.mak
echo. >> %PROJECT_NAME%.mak



rem --- objects ---

set INCLUDE_DIRS=$(BORLAND_INC);$(PROJECT_LIB)
for /R %PROJECT_SOURCE% %%i in (.) do set INCLUDE_DIRS=!INCLUDE_DIRS!;%%~fi
echo INCLUDE_DIRS = %INCLUDE_DIRS% >> %PROJECT_NAME%.mak

set UTILITY_CPPS=
for /R %PROJECT_SOURCE%\utility %%c in (*.cpp) do set UTILITY_CPPS=!UTILITY_CPPS! %%~nxc
echo UTILITY_CPPS = %UTILITY_CPPS% >> %PROJECT_NAME%.mak

set GRAPHICS_CPPS=
for /R %PROJECT_SOURCE%\graphics %%c in (*.cpp) do set GRAPHICS_CPPS=!GRAPHICS_CPPS! %%~nxc
echo GRAPHICS_CPPS = %GRAPHICS_CPPS% >> %PROJECT_NAME%.mak

set WIN32_CPPS=
for /R %PROJECT_SOURCE%\win32 %%c in (*.cpp) do set WIN32_CPPS=!WIN32_CPPS! %%~nxc
echo WIN32_CPPS = %WIN32_CPPS% >> %PROJECT_NAME%.mak

set MAIN_CPPS=
for /R %PROJECT_SOURCE%\main %%c in (*.cpp) do set MAIN_CPPS=!MAIN_CPPS! %%~nxc
echo MAIN_CPPS = %MAIN_CPPS% >> %PROJECT_NAME%.mak

set PLATFORM_CPPS=
for /R %PROJECT_SOURCE%\platform %%c in (*.cpp) do set PLATFORM_CPPS=!PLATFORM_CPPS! %%~nxc
echo PLATFORM_CPPS = %PLATFORM_CPPS% >> %PROJECT_NAME%.mak

echo RC = $(PROJECT_NAME).rc >> %PROJECT_NAME%.mak

echo OBJS = $(UTILITY_CPPS:.cpp=.obj) $(GRAPHICS_CPPS:.cpp=.obj) $(WIN32_CPPS:.cpp=.obj) $(MAIN_CPPS:.cpp=.obj) $(PLATFORM_CPPS:.cpp=.obj) >> %PROJECT_NAME%.mak
echo RES = $(PROJECT_NAME).res >> %PROJECT_NAME%.mak

set LIBS=import32 cw32mt
for /R %PROJECT_LIBS% %%l in (*.lib) do set LIBS=!LIBS! %%~nxl
echo LIBS = %LIBS% >> %PROJECT_NAME%.mak

echo STARTUP = c0w32 >> %PROJECT_NAME%.mak
echo. >> %PROJECT_NAME%.mak



rem --- targets / rules ---

echo $(EXE_NAME): {$(OBJ_DIR)}$(OBJS) $(RES) >> %PROJECT_NAME%.mak
echo 	$(LINKER) @^&^&^|  >> %PROJECT_NAME%.mak
echo 	/j$(OBJ_DIR) /I$(OBJ_DIR) -L"$(LIB_DIRS)" $(LINKER_OPTIONS) $(STARTUP) $(OBJS), $(EXE_NAME), , $(LIBS), , $(RES) >> %PROJECT_NAME%.mak
echo ^| >> %PROJECT_NAME%.mak
echo. >> %PROJECT_NAME%.mak

echo $(RES): $(RESOURCE_DIR)\$(RC) >> %PROJECT_NAME%.mak
echo 	$(RES_COMPILER) -i$(BORLAND_INC) -fo$(OBJ_DIR)\$(RES) $** >> %PROJECT_NAME%.mak
echo. >> %PROJECT_NAME%.mak

echo .cpp.obj: >> %PROJECT_NAME%.mak
echo 	$(COMPILER) -c -n$(OBJ_DIR) -I"$(INCLUDE_DIRS)" $(COMPILER_OPTIONS) {$? } >> %PROJECT_NAME%.mak
rem echo 	echo {$?.cpp } ^> $(PROJECT).compile.lst >> %PROJECT_NAME%.mak
rem echo 	$(COMPILER) -c -n$(OBJ_DIR) -I"$(INCLUDE_DIRS)" $(COMPILER_OPTIONS) @%PROJECT%.compile.lst >> %PROJECT_NAME%.mak
echo. >> %PROJECT_NAME%.mak

for /R %PROJECT_SOURCE% %%t in (*.cpp) do echo %%~nt.obj: %%~ft >> %PROJECT_NAME%.mak



rem --- make output dir ---

mkdir %PROJECT_HOME%\output



rem --- execute the generated file ---

%MAKE% -a -r -f%PROJECT_NAME%.mak



rem --- clean temp files ---

if "%DEBUG%"=="false" (
	del /Q %PROJECT_NAME%.tds %PROJECT_NAME%.map
)
