/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef Transform_h
#define Transform_h


#include "Primitives.h"




#include "hxa7241_graphics.h"
namespace hxa7241 { namespace graphics {
	using namespace hxa7241::primitives;


/**
 * abstract base for a geometric transform.
 */
class Transform
{
/// standard object services -----------------------------------------------------------------------
protected:
	         Transform();
public:
	virtual ~Transform();
protected:
	         Transform( const Transform& );
	Transform& operator=( const Transform& );


/// commands ---------------------------------------------------------------------------------------
public:
	//virtual Transform& operator+=( const Transform& ) =0;


/// queries ----------------------------------------------------------------------------------------
public:
	virtual void  transform( Vector3f& )        const =0;
	virtual void  transform( UnitVector3f& )    const =0;
};








/// INLINES ///


/// standard object services -----------------------------------------------------------------------
inline
Transform::Transform()
{
}


inline
Transform::~Transform()
{
}


inline
Transform::Transform( const Transform& )
{
}


inline
Transform& Transform::operator=( const Transform& )
{
	return *this;
}


}}




#endif//Transform_h
