/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef ProjectableObjectRef_h
#define ProjectableObjectRef_h


#include "Primitives.h"
#include "Transclip.h"
#include "ClipFlags.h"




#include "perceptuum2_modelling.h"
namespace perceptuum2 { namespace modelling {
	using namespace hxa7241::primitives;
	using hxa7241::graphics::Transclip;
	using hxa7241::graphics::ClipFlags;


class ProjectableObjectRef
{
/// standard object services -----------------------------------------------------------------------
public:
	         ProjectableObjectRef();
	         ProjectableObjectRef( const ObjectRenderable* pObject,
	                               const Transclip&        transform,
	                               ClipFlags               clipFlags );

	        ~ProjectableObjectRef();
	         ProjectableObjectRef( const ProjectableObjectRef& );
	ProjectableObjectRef& operator=( const ProjectableObjectRef& );


/// commands ---------------------------------------------------------------------------------------
public:


/// queries ----------------------------------------------------------------------------------------
public:
	         const ObjectRenderable* getObject()    const;
	         const Transclip&        getTransform() const;
	         ClipFlags               getClipFlags() const;


/// fields -----------------------------------------------------------------------------------------
private:
	const ObjectRenderable* pObject_m;
	Transclip               transform_m;
	ClipFlags               clipFlags_m;
};








/// queries ----------------------------------------------------------------------------------------
inline
const ObjectRenderable* ProjectableObjectRef::getObject() const
{
	return pObject_m;
}


inline
const Transclip& ProjectableObjectRef::getTransform() const
{
	return transform_m;
}


inline
ClipFlags ProjectableObjectRef::getClipFlags() const
{
	return clipFlags_m;
}


}}




#endif//ProjectableObjectRef_h
