/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef RasterizationTriangleIm_h
#define RasterizationTriangleIm_h


#include "Primitives.h"
#include "TriangleImplicit.h"




#include "perceptuum2_transport_projection.h"
namespace perceptuum2 { namespace transport { namespace projection {
	using namespace hxa7241::primitives;
	using perceptuum2::modelling::TriangleImplicit;


class RasterizationTriangleIm
	: public TriangleImplicit
{
/// standard object services -----------------------------------------------------------------------
public:
	         RasterizationTriangleIm( const TriangleImplicit&, dword id );

	        ~RasterizationTriangleIm();
	         RasterizationTriangleIm( const RasterizationTriangleIm& );
	RasterizationTriangleIm& operator=( const RasterizationTriangleIm& );


/// commands ---------------------------------------------------------------------------------------
	        void  set( const TriangleImplicit&, dword id );


/// queries ----------------------------------------------------------------------------------------
	        bool  isFrontFacing( const RasterizationVertex*const vertexs[3] ) const;
	        dword getId()                                                     const;


/// fields -----------------------------------------------------------------------------------------
private:
	dword id_m;
};








/// inlines ///


/// queries ----------------------------------------------------------------------------------------
inline
dword RasterizationTriangleIm::getId() const
{
	return id_m;
}


}}}




#endif//RasterizationTriangleIm_h
