/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef RenderDesktopWin32_h
#define RenderDesktopWin32_h


#include "Primitives.h"
#include "RenderDesktop.h"
#include <string>




#include "perceptuum2_platform.h"
namespace perceptuum2 { namespace platform {
	using namespace hxa7241::primitives;
	using perceptuum2::control::RenderDesktop;
	using std::string;


class RenderDesktopWin32
 :	public RenderDesktop
{
/// standard object services -----------------------------------------------------------------------
public:
	                    RenderDesktopWin32( const string& filesPathname, HWND uiHWnd );

	virtual            ~RenderDesktopWin32();
private:
	                    RenderDesktopWin32( const RenderDesktopWin32& );
	RenderDesktopWin32& operator=( const RenderDesktopWin32& );


/// overrides --------------------------------------------------------------------------------------
protected:
	virtual void  attendToLineDone( dword lineNumber );
	virtual void  attendToFrameDone( bool shouldRepaint );
	virtual void  attendToRenderDone( bool shouldRepaint );


/// implementation ---------------------------------------------------------------------------------
	virtual void  sendMessageToWindow( udword message, dword param ) const;


/// fields -----------------------------------------------------------------------------------------
	HWND uiHWnd_m;
};


}}




#endif//RenderDesktopWin32_h
