/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef Win32Exception_h
#define Win32Exception_h


#include "Primitives.h"
#include "Exception.h"
#include "stdwin.h"


/// for borland c++ 5.5.1 (another at the end of the file)
#ifdef BORLANDCPP551
#pragma option push -b -a8 -pc -Vx- -Ve- -w-inl -w-aus -w-sig
#endif




#include "hxa7241_win32.h"
namespace hxa7241 { namespace win32 {
	using namespace hxa7241::primitives;
	using hxa7241::utility::Exception;
	using std::string;


class Win32Exception
	: public Exception
{
/// standard object services -----------------------------------------------------------------------
public:
	                /**
	                 * string args must be pointers to statics.
	                 */
	                Win32Exception( UINT messageResourceId,
	                                const char* pClassName, const char* pMethodName ) throw();
	                Win32Exception( UINT messageResourceId, DWORD errorCode,
	                                const char* pClassName, const char* pMethodName ) throw();
	                Win32Exception( const char* pMessage,   DWORD errorCode,
	                                const char* pClassName, const char* pMethodName ) throw();

	virtual        ~Win32Exception()                        throw();
	                Win32Exception( const Win32Exception& ) throw();
	Win32Exception& operator=( const Win32Exception& )      throw();


/// implementation ---------------------------------------------------------------------------------
protected:
	virtual string&     appendMessage( string& )        const;

	virtual string&     appendWin32Message( string& )   const;
	static  string&     append( const TCHAR*, string& );

	virtual void        assign( const Exception& );


/// fields -----------------------------------------------------------------------------------------
private:
	UINT   messageResourceId_m;
	DWORD  errorCode_m;

protected:
	/// constants
	static const char DEFAULT_WIN32MESSAGE[];
};


}}




#ifdef BORLANDCPP551
#pragma option pop
#endif


#endif//Win32Exception_h
